Salesforce SOAP Apex app
===========================================

Allows invoking methods from Apex classes that have been deployed to Salesforce and exposed as SOAP web services.

Installation and Usage
----------------------

Import the demo project into your workspace
Fill in all the values in /main/app/mule.properties

Run the project in Studio.
First take a look at create_metadata_app. Add it to the workspace and 
run it in order to add a custom object called Custom Order to your organization.

After running the create_metadata_app run the apex_app.
The deploy_apex flow will run and deploy the zip from /resources/in. 
That means that the Apex class CustomOrderUtils that is declared in demo_apex_class.zip will be deployed to you organization.



At this point you are ready to start invoking the methods from the Apex class CustomOrderUtils.
In invoke_custom_object_utils.xml there are 3 flows declared, each listening to a different HTTP endpoint.

Run the demo project and  in the browser hit - http://localhost:8081, the result would be a website that consists of three operations (Create Order, List All Orders, List Some Orders).

1. Create Order

** You can input an Order Value and a Product Ordered. Hit Create Order and it will call the creation flow.
You can create several instances in a similar manner.

2. List All Orders

** Calling it will result in listing all the Custom Orders previously created 
(the Id of the object will be listed since that is the only field mapped in DataMapper, for other fields please create a mapping in DataMapper).

3. List Some Orders

** You can input a Product Name (same as Product Ordered) and it will result in the flow invoking the listAllCustomOrdersThatContainProduct method from CustomOrderUtils,
that lists the all the Custom Orders that have a ProductName that contains the String given as parameter.


The mappings for input TransformMessage were created based on the files from src/main/resources, which are list_some_orders.json and order_example.json respectively.

