global class CustomOrderUtils {

  webService static void createOrder(String productOrdered, String orderValue) {
    CustomOrder__c order = new CustomOrder__c();
    order.ProductName__c = productOrdered;
    order.ProductValue__c = orderValue;
    insert order;
  }
  
  webService static List<CustomOrder__c> listAllCustomOrders() {
    List<CustomOrder__c> allCustomOrders = [SELECT ProductName__c , ProductValue__c FROM CustomOrder__c];      
      return allCustomOrders;
  }
  
  webService static List<CustomOrder__c> listAllCustomOrdersThatContainProduct(String productName) {
    List<CustomOrder__c> allCustomOrders = [SELECT ProductName__c , ProductValue__c FROM CustomOrder__c];
    List<CustomOrder__c> someCustomOrders = new List<CustomOrder__c>();
    for(CustomOrder__c customer : allCustomOrders)
    {
        if(customer.ProductName__c.contains(productName))
        {
            someCustomOrders.add(customer);
        }
    }
      return someCustomOrders;
  }
}